SonarQube Branch Report:
  stage: CodeQuality Report
  image:
    name: sonarsource/sonar-scanner-cli:latest # uses alpine for buildings
    entrypoint: [""]
  tags:
    - kubernetes
  rules:
    - if: '$CODE_QUALITY_DISABLED'
      when: never
    - if: '$SONAR_TOKEN == null || $SONAR_TOKEN == "" || $SONAR_HOST_URL == "" || $SONAR_HOST_URL == null'
      when: never
    - if: $CI_COMMIT_TAG
      when: never
    - if: '$CI_COMMIT_TITLE =~ /^hot-fix.*/'
      when: never
    - if: '$CI_PIPELINE_SOURCE == "push" || $CI_PIPELINE_SOURCE == "web"'
  allow_failure: true
  variables:
    SONAR_USER_HOME: "${CI_PROJECT_DIR}/.sonar"  # Defines the location of the analysis task cache
    GIT_DEPTH: "0"  # Tells git to fetch all the branches of the project, required by the analysis task
  script:
    - |
      sonar-scanner \
        -Dsonar.projectKey=$CI_PROJECT_PATH_SLUG \
        -Dsonar.branch.name=$CI_COMMIT_BRANCH \
        -Dsonar.qualitygate.wait=true \
        -Dsonar.scm.provider=git \
        -Dsonar.sources="." \
        -Dsonar.eslint.reportPaths="lint.report.json" \
        -Dsonar.exclusions="**/node_modules/**,**/public/**"
  cache:
    key: "${CI_JOB_NAME}"
    paths:
      - .sonar/cache

SonarQube Merge Report:
  stage: CodeQuality Report
  image:
    name: sonarsource/sonar-scanner-cli:latest
    entrypoint: [""]
  tags:
    - kubernetes
  rules:
    - if: '$CODE_QUALITY_DISABLED'
      when: never
    - if: '$SONAR_TOKEN == null || $SONAR_TOKEN == "" || $SONAR_HOST_URL == "" || $SONAR_HOST_URL == null'
      when: never
    - if: '$CI_COMMIT_TITLE =~ /^hot-fix.*/'
      when: never
    - if: '$CI_MERGE_REQUEST_TARGET_BRANCH_NAME != "master" && $CI_MERGE_REQUEST_TARGET_BRANCH_NAME != "staging"'
      when: never
    - if: '$CI_MERGE_REQUEST_EVENT_TYPE != "detached"'
      when: never
    - if: '$CI_PIPELINE_SOURCE == "merge_request_event"'
  allow_failure: true
  variables:
    SONAR_USER_HOME: "${CI_PROJECT_DIR}/.sonar"  # Defines the location of the analysis task cache
    GIT_DEPTH: "0"  # Tells git to fetch all the branches of the project, required by the analysis task
  script:
    - |
      sonar-scanner \
        -Dsonar.projectKey=$CI_PROJECT_PATH_SLUG \
        -Dsonar.pullrequest.provider=gitlab \
        -Dsonar.pullrequest.key=$CI_MERGE_REQUEST_IID \
        -Dsonar.pullrequest.branch=$CI_MERGE_REQUEST_SOURCE_BRANCH_NAME \
        -Dsonar.pullrequest.base=$CI_MERGE_REQUEST_TARGET_BRANCH_NAME \
        -Dsonar.pullrequest.gitlab.projectId=${CI_MERGE_REQUEST_PROJECT_PATH} \
        -Dsonar.gitlab.commit_sha=${CI_MERGE_REQUEST_SOURCE_BRANCH_SHA} \
        -Dsonar.gitlab.ref_name=${CI_COMMIT_REF_NAME} \
        -Dsonar.qualitygate.wait=true \
        -Dsonar.scm.provider=git \
        -Dsonar.sources="." \
        -Dsonar.php.phpstan.reportPaths="lint.report.json" \
        -Dsonar.exclusions="**/vendor/**,**/public/**,**/tests/**"
  cache:
    key: "${CI_JOB_NAME}"
    paths:
      - .sonar/cache
